#include<iostream>
#include<string>
#include<vector>
using namespace std;
string tab[501];
int dx[] = { -1, -0, +0, +1 };
int dy[] = { -0, -1, +1, +0 };
int cost (char num1, char num2) {
    if (num1<num2) return num2-num1;
    return num1-num2;
}
struct cell {
    int x,y;
};
vector <cell> minq[5000];
int n,m,minside[501][501][4],ans=1e9;
int used[501][501];
int dijkstra (int state, char colour, int time) {
    cell curr,temp;
    int x,y,min1=1e9,i,j,dist;
    for (dist=0; dist<(n+m)*5; dist++) {
        if ((dist>=ans)||(dist>=min1)) break;
        for (j=0; j<minq[dist].size(); j++) {
            curr=minq[dist][j];
            if (used[curr.x][curr.y]==time*6+state+1) continue;
                //cout << state << " " << curr.x << " " << curr.y << endl ;
                //cout << "b";
            if (curr.x==-1) break;
            x=curr.x; y=curr.y;
            if (state<4) minside[x][y][state]=dist;
            else if (state==4) min1=min(min1,dist+minside[x][y][2]+minside[x][y][3]-2*cost(tab[x][y],colour));
            else min1=min(min1,dist+minside[x][y][0]+minside[x][y][2]-2*cost(tab[x][y],colour));
            used[x][y]=time*6+state+1;
            for (i=0; i<4; i++) {
                temp.x=x+dx[i]; temp.y=y+dy[i];
                if ((temp.x<0)||(temp.x>=n)||(temp.y<0)||(temp.y>=m)) continue;
                if (used[temp.x][temp.y]<time*6+state+1) minq[dist+cost(tab[temp.x][temp.y],colour)].push_back(temp);
                }
            }
        minq[dist].clear();
        }
    return min1;
}
int digs[]={4,5,3,6,2,7,1,8,0,9};
int main () {
    int i,j,h,x,y,t;
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> m ;
    for (i=0; i<n; i++) {
        cin >> tab[i] ;
        }
    for (i=0; i<10; i++) {
        for (j=0; j<n; j++) {
            for (h=0; h<m; h++) {
                minside[j][h][0]=minside[j][h][1]=minside[j][h][2]=minside[j][h][3]=1e4;
                }
            }
        for (j=0; j<4; j++) {
            for (h=0; ; h++) {
                if (((j==0)||(j==3))&&(h>=m)) break;
                if (((j==1)||(j==2))&&(h>=n)) break;
                if (j==0) x=0, y=h;
                else if (j==1) x=h, y=0;
                else if (j==2) x=h, y=m-1;
                else x=n-1, y=h;
                if (cost(tab[x][y],digs[i]+'0')>=ans) continue;
                minq[cost(tab[x][y],digs[i]+'0')].push_back({x,y});
                }
            dijkstra(j,digs[i]+'0',i);
            }
        for (j=0; j<n; j++) {
            for (h=0; h<m; h++) {
                ans=min(ans,minside[j][h][0]+minside[j][h][1]+minside[j][h][2]+minside[j][h][3]-3*cost(tab[j][h],digs[i]+'0'));
                }
            }
        //cout << i << " " << ans << endl ;
        }
    cout << ans ;
    cout << endl ;
    return 0;
}
